#include "armemul.h"
#include "misc.h"
#include "ns_arm.h"

/* in the future, use queue on each address to solve the problem. */


using namespace emulator;

void impl_ns_arm(armulator *emu, arm_inst_t inst)
{

  //fprintf(stderr, "entering ns_arm\n");

// fprintf(stderr, " ns_arm.h: our address = %d\n", emu->pe_address);
	/* if already in fpe, then must be an exit */
	if (inst & (0x00100000)) {
          // in the sending case
          // the third argument is the length
          int length = READ_REG(2); 
          int i0;
	  //fprintf(stderr, "entering ns_arm ldc\n");
          // destination address is in r0
          unsigned  destination = READ_REG(0);
          // data is in r1
           for(i0 = 0; i0 < length; i0++){
               UInt32 a = MEM_READ_WORD((RN+(i0*4)));
               //fprintf(stderr, "entering ns_arm ldc , (%d, %d)of seq =%d\n",a,destination, i0);
               ns_data data(destination, a); 
               (emu->output_queue).push(data);
	  }
	  
          
          // return value, >0 = length of written, -1 failure
          WRITE_REG(0, length);

	}else{
	  //in the stc case 

          /* see if this is the get_arm_addres */
          if (RSFLD > 0){
	    /* cp number = 8, is the recv case */
	  unsigned int length = RD; unsigned int i0;
          unsigned source = READ_REG(0);  
          if ((emu->input_queue[source]).size()>=length){
            // received value in r
            
            for(i0 = 0; i0 < length; i0++){
               ns_data value = (emu->input_queue[source]).front();
               (emu->input_queue[source]).pop();
               MEM_WRITE_WORD((RN+(i0*4)), value.second);
               //fprintf(stderr, "ns_arm recv (%d, %d)of seq = %d\n", value.second, source, i0);
	    }
            // return value in r0
            WRITE_REG(0,length);
            
            
	  }else{
	    // no data yet.
            // received value in r5
            //WRITE_REG(RNFLD, 0);
            for(i0 = 0; i0 < length; i0++){
               MEM_WRITE_WORD((RN+(i0*4)),(unsigned) -1);
	    }
            // return value in r0
            WRITE_REG(0,(unsigned) -1);
            //fprintf(stderr, "entering ns_arm recv no data , rd =%d, dest = %d, rd_feld = %d\n",length, destination, RDFLD);
	  }
	  }else{
	    /* cp number = 0, is the get_arm_address */
            /* write to R0 with the address value */
            WRITE_REG(0, emu->pe_address);
 //           fprintf(stderr, " ns_arm.h: our address = %d\n", emu->pe_address);	   
            //fprintf(stderr, "entering ns_arm stc address = %d \n", emu->pe_address);
	  }
	}
}

char *disasm_ns_arm(arm_inst_t inst, arm_addr_t addr, char *buf)
{
	/* binary operations */
		buf += sprintf(buf, ", ");
		buf += sprintf(buf, ", ");
		return buf;

}
