/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef __STATREG_H__
#define __STATREG_H__

typedef emulator::arm_emulator armulator;

void impl_mrs(armulator *emu, arm_inst_t inst);		/*0x10*/
void impl_mrs_r(armulator *emu, arm_inst_t inst);	/*0x14*/

void impl_msr_1(armulator *emu, arm_inst_t inst);	/*0x32*/
void impl_msr_1r(armulator *emu, arm_inst_t inst);	/*0x36*/

void impl_msr_2(armulator *emu, arm_inst_t inst);	/*0x12*/
void impl_msr_2r(armulator *emu, arm_inst_t inst);	/*0x16*/

char *disasm_mrs(arm_inst_t, arm_addr_t, char *);		/*0x10*/
char *disasm_mrs_r(arm_inst_t, arm_addr_t, char *);	/*0x14*/

char *disasm_msr_1(arm_inst_t, arm_addr_t, char *);	/*0x32*/
char *disasm_msr_1r(arm_inst_t, arm_addr_t, char *);	/*0x36*/

char *disasm_msr_2(arm_inst_t, arm_addr_t, char *);	/*0x12*/
char *disasm_msr_2r(arm_inst_t, arm_addr_t, char *);	/*0x16*/

#define incr_mrs INST_MRS
#define incr_mrs_r INST_MRS

#define incr_msr_1 INST_MSR
#define incr_msr_1r INST_MSR
#define incr_msr_2 INST_MSR
#define incr_msr_2r INST_MSR

#endif
