/***************************************************************************
                          syscall.h  -  description
                             -------------------
    begin                : Wed Sep 26 2001
    copyright            : (C) 2001 CEA and Universit Paris XI Orsay
    author               : Gilles Mouchard
    email                : gilles.mouchard@lri.fr, gilles.mouchard@cea.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __SYSCALL_H__
#define __SYSCALL_H__

#include "armemul.h"

typedef emulator::arm_emulator armulator;

#if 0
typedef struct
{
	/* Registers interface */
	void (*write_gpr)(void *, int, word_t);
	word_t (*read_gpr)(void *, int);
	
	/* Memory interface */
	byte_t (*mem_read_byte)(void *, target_addr_t);
	void (*mem_write_byte)(void *, target_addr_t, byte_t);
	halfword_t (*mem_read_half_word)(void *, target_addr_t);
	void (*mem_write_half_word)(void *, target_addr_t, halfword_t);
	word_t (*mem_read_word)(void *, target_addr_t);
	void (*mem_write_word)(void *, target_addr_t, word_t);
	dword_t (*mem_read_dword)(void *, target_addr_t);
	void (*mem_write_dword)(void *, target_addr_t, dword_t);
	void (*mem_set)(void *, target_addr_t, byte_t, int);
	void (*mem_read)(void *, void *, target_addr_t, int);
	void (*mem_write)(void *, target_addr_t, void *, int);
	
	
	void *instance;
} syscall_cb_t;

extern void syscall_init(syscall_cb_t *cb, BOOL verbose, BOOL emulate, void (*exit_proc)(int));
extern void syscall_setcb(syscall_cb_t *cb);
extern void syscall_getcb(syscall_cb_t *cb);
extern void syscall_setbrk(target_addr_t addr);
#endif
extern void sc_impl(armulator *emu, arm_inst_t inst);
extern char *sc_disasm(arm_inst_t inst, target_addr_t pc, char *buf);
extern void do_syscall(armulator *emu, arm_inst_t inst);

#define impl_sc sc_impl
#define disasm_sc sc_disasm
#define incr_sc INST_SYSCALL

#endif
