
#ifndef SC_ADDRESS_H
#define SC_ADDRESS_H

#define SR_MAX 10

#define NORTH 3
#define EAST 2
#define SOUTH 1
#define WEST 4
#define EXIT 0

#define DEBUG 0 

#define LENGTH 1
#define HEAD 1
#define BODY 2
#define TAIL 3

int get_next_toru_east(int address, int dimension){

  int address_x, address_y;

  address_x = address/dimension;

  address_y = address%dimension;

  /* if it's on the west edge, then return otherwise */

 if (address_x == (dimension-1))  return address_y;

  return (address + dimension);
  
}
int get_next_toru_west(int address, int dimension){

  /* go through the whole list and locate the instance name with the
   *  needed adjointed address
   */
  int address_x, address_y;

  address_x = address/dimension;

  address_y = address%dimension;

  /* if it's on the west edge, then return otherwise */

  if (address_x == 0)  return (dimension-1)*dimension + address_y;

  return (address - dimension);

}
int get_next_toru_south(int address, int dimension){

  /* go through the whole list and locate the instance name with the
   *  needed adjointed address
   */
  int address_x, address_y;

  address_x = address/dimension;

  address_y = address%dimension;

  /* if it's on the south edge, then return failed */

  if (address_y == 0)  return (address+dimension-1);

  return (address-1);

}

int get_next_toru_north(int address, int dimension){

  /* go through the whole list and locate the instance name with the
   *  needed adjointed address
   */
 int address_x, address_y;

  address_x = address/dimension;

  address_y = address%dimension;

  /* if it's on the south edge, then return failed */

  if (address_y == (dimension-1))  return (address-dimension+1);

  return (address+1);

}

int  do_compute_addr_xy(int x, int y, int size){
  return (x*size+ y);
}


int do_gen_rand_torus_addr(int src_addr, int TORUS_SIZE){
  int d_y, d_x, dest_addr;
  d_y =(src_addr%TORUS_SIZE);  d_x = (src_addr/TORUS_SIZE);
  while(do_compute_addr_xy(d_x, d_y, TORUS_SIZE) == src_addr){
    d_y = ((int)(((float)100.0) * ( rand() /( RAND_MAX+1.0))))%TORUS_SIZE;
    d_x = ((int)(((float)100.0) * ( rand() /( RAND_MAX+1.0))))%TORUS_SIZE;
  }
  dest_addr = do_compute_addr_xy(d_x,d_y, TORUS_SIZE);
  return dest_addr;
}


int do_compute_x_torus_route(int src, int dest, int size){

  /* use mask-based caculationg to compute the (x,y) pair of each addr*/
  int r[SR_MAX];
  int i, j, length = 0;

  int routes = 0;
  int src_x, src_y, dest_x, dest_y;
  int z = size /2;
  src_x = src/size; src_y = src%size;
  dest_x = dest/size; dest_y = dest%size;
  
  for (i=0; i< SR_MAX; i++){
    
    /* go Y-axis first */
    
    /* go minimum routing */
    if ((src_y < dest_y) && ((dest_y - src_y) <= z) || ((src_y > dest_y) && ((src_y - dest_y) > z))) {
      r[i] = NORTH;
      src_y ++;
      if (src_y == size) src_y = 0; 
    }else if ((src_y < dest_y) && ((dest_y - src_y) > z) || ((src_y > dest_y) && ((src_y - dest_y) <= z)))    {
      r[i] = SOUTH;
      src_y --;
      if (src_y == -1) src_y = size-1; 
    }else if (src_y == dest_y){

      /* then go X-axis */
      if ((src_x < dest_x) && ((dest_x - src_x) <= z) || ((src_x > dest_x) && ((src_x - dest_x) > z))){
        r[i] = EAST;
        src_x ++;
        if (src_x == size) src_x = 0; 
      }else if ((src_x < dest_x) && ((dest_x - src_x) > z) || ((src_x > dest_x) && ((src_x - dest_x) <= z))) {
        r[i] = WEST;
        src_x --;
        if (src_x == -1) src_x = size-1; 
      }else if ((src_x == dest_x)){
        r[i] = EXIT;
        length =i;
        break;
      }
    }
  }
  for (j=length; j>=0; j--){
    routes = routes * 10 + r[j];
    /*
     if (DEBUG == 1){
       fprintf(stdout, "r[%d] = %d\n", j, r[j]);
     }
    */ 
    }
    if (DEBUG == 1){
      fprintf(stdout, "compute torus route = %d, src = %d, dest=%d\n", routes, src, dest);
    }
  return routes;
}


int do_compute_rand_torus_route(int src, int dest, int size){

  /* use mask-based caculationg to compute the (x,y) pair of each addr*/
  int r[SR_MAX];
  int i, j, length = 0;
  int routes = 0;
  int src_x, src_y, dest_x, dest_y;
  int z = size /2;
  src_x = src/size; src_y = src%size;
  dest_x = dest/size; dest_y = dest%size;
  
  for (i=0; i< SR_MAX; i++){
    
    /* go Y-axis first */
     float r1, r2;
     r1 = 50.0;
     r2 = ((float)(100.0*rand()/(RAND_MAX+1.0)));
     if (r1> r2){
    /* go minimum routing */
    if ((src_y < dest_y) && ((dest_y - src_y) <= z) || ((src_y > dest_y) && ((src_y - dest_y) > z))) {
      r[i] = NORTH;
      src_y ++;
      if (src_y == size) src_y = 0; 
    }else if ((src_y < dest_y) && ((dest_y - src_y) > z) || ((src_y > dest_y) && ((src_y - dest_y) <= z)))    {
      r[i] = SOUTH;
      src_y --;
      if (src_y == -1) src_y = size-1; 
        } 
     else if (src_y == dest_y){

      /* then go X-axis */
      if ((src_x < dest_x) && ((dest_x - src_x) <= z) || ((src_x > dest_x) && ((src_x - dest_x) > z))){
        r[i] = EAST;
        src_x ++;
        if (src_x == size) src_x = 0; 
      }else if ((src_x < dest_x) && ((dest_x - src_x) > z) || ((src_x > dest_x) && ((src_x - dest_x) <= z))) {
        r[i] = WEST;
        src_x --;
        if (src_x == -1) src_x = size-1; 
      }else if ((src_x == dest_x)){
        r[i] = EXIT;
        length =i;
        break;
       }
      }
     }else {
       // go X-axis first 
      if ((src_x < dest_x) && ((dest_x - src_x) <= z) || ((src_x > dest_x) && ((src_x - dest_x) > z))){
        r[i] = EAST;
        src_x ++;
        if (src_x == size) src_x = 0; 
      }else if ((src_x < dest_x) && ((dest_x - src_x) > z) || ((src_x > dest_x) && ((src_x - dest_x) <= z))) {
        r[i] = WEST;
        src_x --;
        if (src_x == -1) src_x = size-1; 
      }else if( src_x == dest_x){
        // then go Y-axis
     if ((src_y < dest_y) && ((dest_y - src_y) <= z) || ((src_y > dest_y) && ((src_y - dest_y) > z))) {
      r[i] = NORTH;
      src_y ++;
      if (src_y == size) src_y = 0; 
    }else if ((src_y < dest_y) && ((dest_y - src_y) > z) || ((src_y > dest_y) && ((src_y - dest_y) <= z)))    {
      r[i] = SOUTH;
      src_y --;
      if (src_y == -1) src_y = size-1; 
        }
     else if  ((src_y == dest_y)){
        r[i] = EXIT;
        length =i;
        break;
       }
      }
     }
    }
  for (j=length; j>=0; j--){
    routes = routes * 10 + r[j];
    /*
     if (DEBUG == 1){
       fprintf(stdout, "r[%d] = %d\n", j, r[j]);
     }
    */ 
    }
    if (DEBUG == 1){
      fprintf(stdout, "compute torus route = %d, src = %d, dest=%d\n", routes, src, dest);
    }
  return routes;
}

int do_compute_y_torus_route(int src, int dest, int size){

  /* use mask-based caculationg to compute the (x,y) pair of each addr*/
  int r[SR_MAX];
  int i, j, length = 0;
  int routes = 0;
  int src_x, src_y, dest_x, dest_y;
  int z = size /2;
  src_x = src/size; src_y = src%size;
  dest_x = dest/size; dest_y = dest%size;
  
  for (i=0; i< SR_MAX; i++){
    
   
       // go X-axis first 
      if ((src_x < dest_x) && ((dest_x - src_x) <= z) || ((src_x > dest_x) && ((src_x - dest_x) > z))){
        r[i] = EAST;
        src_x ++;
        if (src_x == size) src_x = 0; 
      }else if ((src_x < dest_x) && ((dest_x - src_x) > z) || ((src_x > dest_x) && ((src_x - dest_x) <= z))) {
        r[i] = WEST;
        src_x --;
        if (src_x == -1) src_x = size-1; 
      }else if( src_x == dest_x){
        // then go Y-axis
     if ((src_y < dest_y) && ((dest_y - src_y) <= z) || ((src_y > dest_y) && ((src_y - dest_y) > z))) {
      r[i] = NORTH;
      src_y ++;
      if (src_y == size) src_y = 0; 
    }else if ((src_y < dest_y) && ((dest_y - src_y) > z) || ((src_y > dest_y) && ((src_y - dest_y) <= z)))    {
      r[i] = SOUTH;
      src_y --;
      if (src_y == -1) src_y = size-1; 
        }
     else if  ((src_y == dest_y)){
        r[i] = EXIT;
        length =i;
        break;
       }
      }
     }
    
  for (j=length; j>=0; j--){
    routes = routes * 10 + r[j];
    /*
     if (DEBUG == 1){
       fprintf(stdout, "r[%d] = %d\n", j, r[j]);
     }
    */ 
    }
    if (DEBUG == 1){
      fprintf(stdout, "compute torus route = %d, src = %d, dest=%d\n", routes, src, dest);
    }
  return routes;
}

int do_compute_random_torus_route(int src, int dest, int size){

      
    /* go Y-axis first */
     float r1, r2;
     r1 = 50.0;
     r2 = ((float)(100.0*rand()/(RAND_MAX+1.0)));
     if (r1> r2){
       return do_compute_x_torus_route(src, dest, size);
     }else{
       return do_compute_y_torus_route(src, dest, size);
     }
}


#endif

// Taf!

