#ifndef NS_FLIT_H
#define NS_FLIT_H

#define HEAD 1
#define BODY 2
#define TAIL 3

#include <systemc.h>
#include <stdlib.h>
#include <iostream.h>
class Flit{

public:
  Flit(int i, int j, int k, int l);
  Flit(int i, int j, int k, int l, int m);
  Flit();
  Flit(int size);
  Flit & operator++(); //prefix ++
  Flit operator++(int); //prefix --
  void set_size(int);
  void set_addr(int);
  void set_length(int);
  int get_length();

  int get_addr();
  int get_dest_addr();
  void set_dest_addr();
  void set_dest_addr(unsigned);
  void set_route(int);
  int get_route();
  void set_time(sc_time);
  sc_time get_time();
  void set_packet_id(int);
  int get_packet_id();
  void set_type(int);
  int get_type();
  void set_input_vc(int);
  int get_input_vc();
  void set_output_vc(int);
  int get_output_vc();
  int get_next_route();
  void update_route();
  int calc_dest_addr(int,int);
  void set_payload(int payload_);
  int get_payload();
  friend ostream& operator <<(ostream& aor, Flit& f){

  aor << "id=" << f.packet_id << " src=" << f.src_addr << " dest=" << f.dest_addr << " type=" << f.type<< endl;
  return aor;

};

  int id;
  int src_addr;
  int dest_addr;
  int input_vc;
  int output_vc;
  int route;
  int type;
  int packet_id;
  int length;
  long payload;
  sc_time time;
private:
  int size_;
  static const int max_route_length_ = 10;
};

int Flit::get_packet_id(){

  return packet_id;
}

void Flit::set_packet_id(int packet_id_){
  packet_id = packet_id_;
}

sc_time Flit::get_time(){
  return time;
}

void Flit::set_time(sc_time time_){

  time = time_;
}

int Flit::get_type(){
  return type;
}

void Flit::set_type(int type_){

  type = type_;
}

void Flit::set_length(int len){

  length = len;
}

int Flit::get_length(){

  return length;
}

int Flit::get_payload(){
  return payload;
}

void Flit::set_payload(int payload_){

  payload = payload_;
}

int Flit::get_route(){

  return route;
}

int Flit::get_next_route(){

  return route%max_route_length_;
}

void Flit::update_route(){

  route = route/max_route_length_;
}

void Flit::set_route(int route_){

  route = route_;
}

int Flit::get_input_vc(){

  return input_vc;
}
int Flit::get_output_vc(){

  return output_vc;
}

void Flit::set_input_vc(int input_vc_){

  input_vc = input_vc_;
}

void Flit::set_output_vc(int output_vc_){

  output_vc = output_vc_;
}

void Flit::set_size(int size){

  size_ = size;
}

void Flit::set_addr(int addr){

  src_addr = addr;
}

int Flit::get_addr(){

  return src_addr;
}

int Flit::get_dest_addr(){

  return dest_addr;
}

void Flit::set_dest_addr(){
   dest_addr =  calc_dest_addr(src_addr, size_);
  return;
}

void Flit::set_dest_addr(unsigned dest_addr_){
  dest_addr =  dest_addr_;
  return;
}
int Flit::calc_dest_addr(int s_addr, int max_size){
  int i;
  while (1){
    i = rand()%max_size;
    if ( i != s_addr){
      return i;
     } 
  }
  
}

Flit::Flit(int i, int j, int k, int l){

 srand(1234);
 id = i;
 src_addr = j;
 dest_addr = k;
 route = k;
 payload = rand(); 
 input_vc = 0;
 output_vc = 0;
 size_= 5;
}

Flit::Flit(){

 id = 1;
 src_addr = 0;
 dest_addr = 0;
 route = 0;
 payload = 0;
 input_vc = 0;
 output_vc = 0;
 size_= 5;
}

Flit::Flit(int size){

 id = 1;
 src_addr = 0;
 dest_addr = calc_dest_addr(src_addr, size);
 route = 0;
 payload = 0;
 size_= size;
 input_vc = 0;
 output_vc = 0; 
}
Flit::Flit(int i, int j, int k, int l, int m){

 id = i;
 src_addr = j;
 dest_addr = calc_dest_addr(src_addr, 5);
 route = k;
 payload = m;
 size_= 5;
 input_vc = 0;
 output_vc = 0;
 
}

Flit& Flit::operator++(){

 id++;
 // dest_addr = calc_dest_addr(src_addr, size_);;
 set_dest_addr();
 //route = do_compute_torus_route(src_addr,dest_addr, size_);
 return *this;
}

Flit Flit::operator++(int){

 Flit ans = *this;
 ++(*this);
 return ans;
}


#endif
