
//****************************************************************************
//****************************************************************************
//
//
//****************************************************************************
//****************************************************************************


//
// Example using the simple abstract crossbar model
// introduced in section 9.5.
//



#include <systemc.h>
#include <cstdio>
#include <csignal>
#include <cstring>
#include <cstdlib>
#include "armemul.h"
#include "config.h"
#include "loader.h"
#include <string>
using namespace emulator;
static arm_emulator *mltr = NULL;
static void sigint_handler(int signum)
{
        if (mltr->is_running()) {
                mltr->stop();
        }
        else if (mltr->is_debugging()) {
                mltr->stop_debug();
        }
        else exit(0);
}

int sc_main(int argc, char* argv[])
{       void (*prev_sigint_handler)(int);
        int i;
        char *prog_name = NULL;
        bool verbose = false;
        bool debuging = false;
        char *fpe_name = NULL;
        UInt64 max_inum = (UInt64)-1;
		char *env[] = {NULL};

        for(i = 1; i < argc; i++)
        {
                if(strcmp(argv[i], "-d") == 0) debuging = true; else
                if(strcmp(argv[i], "-v") == 0) verbose = true; else
                if(strcmp(argv[i], "-f") == 0) fpe_name = argv[++i]; else
                if(!prog_name)
                {
                        prog_name = argv[i];
                        break;
                }
        }

        if(prog_name)
         {
                /* emulator instance */
                arm_emulator ema(verbose, true);

                mltr = &ema;
                ema.load_fpe(fpe_name);
                ema.load_program(prog_name, argc - i, argv + i, env);

                prev_sigint_handler = signal(SIGINT, sigint_handler); 

                if(debuging)
                        ema.debug();
                else
                        ema.run(max_inum);

             arm_emulator ema1(verbose, true);

                mltr = &ema1;
                ema1.load_fpe(fpe_name);
                ema1.load_program(prog_name, argc - i, argv + i, env);

                prev_sigint_handler = signal(SIGINT, sigint_handler); 

                if(debuging)
                        ema1.debug();
                else
		  ema1.run(max_inum);
                 
	 }


return 0;

}

