#ifndef NS_ROUTER_H
#define NS_ROUTER_H


SC_MODULE(ns_router) { 

    // ports
    sc_fifo_out<int> select;

    // data
    int arbiter_size_;
    int token_;
    int max_size;
    
    int *port_list;
    int *request_port;
    // constructors
    SC_HAS_PROCESS(ns_router);
    
   
    ns_router(sc_module_name nm, int arbiter_size)
      : sc_module(nm), arbiter_size_(arbiter_size), max_size(10) 
    { 
        SC_METHOD(dummy_fun);
        dont_initialize();
        cursor_last_ = 0;
        port_list = new int [arbiter_size_];
        request_port = new int [arbiter_size_];
        for (int i =0; i < arbiter_size_; i++){
          request_port[i] = -1;
        }
    }
    
    void dummy_fun(){

    }

 
  /* build the selection token from the array */
  int make_select_token(int * p_l, int count){
    int i, value=0;

   for (i=0;i<count;i++){
    if(p_l[i] == -1){
      value = value * max_size  + (max_size - 1);
    }else{
      value = value * max_size  + p_l[i];
     }
    }
    return value;
   }
  void print_port_list(int * dest_p){
    /* init the port_list */
      for (int i =0; i < arbiter_size_; i++){
        cout << "dest_p " << i <<" " << dest_p[i] <<endl;
      }
  }

  void store_request(int * dest_p){

    for (int i =0; i < arbiter_size_; i++){
      request_port[i] = dest_p[i];
      }
  }

  void process_vc_request() { 
    
  }
  // processes
  void process_request() { 
      
        /* go through all the destination port to make grant list 
         * description of the algorithm:
         * 
         *   0     1    2    3   4        input port
         * ------------------------
         * |  2  | 3  | 4  | 1 |  0|      wanted output port
         *        {c}
         *  it has a cursor, to do round-robin grant
         *  if the output port it pointed hasn't been granted, then grant
         *  if yes, move the cursor to the next one. and remember the 
         *  last cursor. 
         */
      int cursor;
      cursor = cursor_last_;
      cursor_last_ = (++cursor_last_) % arbiter_size_;
      assert((cursor_last_ >= 0) && (cursor_last_ <arbiter_size_));
      /* init the port_list */
      for (int i =0; i < arbiter_size_; i++){
        port_list[i] = -1;
      }
      //print_port_list(request_port);
      for (int i =0; i < arbiter_size_; i++){
        if ( request_port[cursor] != -1){
         if (port_list[request_port[cursor]] ==-1){
          /* found an empty output port*/
          port_list[request_port[cursor]] = cursor;
	  // cout << "assigned " <<request_port[cursor] << " " <<cursor <<endl;
         }
	}
        cursor = (++cursor) % arbiter_size_;
        assert((cursor >=0) && (cursor<arbiter_size_));
      }
      
        /* write the token out to the crossbar */
          token_= make_select_token(port_list, arbiter_size_);
          select.write(token_);
          
    }

 protected:
    int cursor_last_;

}; 



#endif
