
#include "manager.h"
#include "token.h"
#include "object.h"

using std::string;
using namespace osm;

manager::manager(int n, const string &nm) : nTotal(n), name(nm)
{
	tokens = new Token[n](this);
	for (int i=0; i<n; i++) tokens[i].setIndex(i);
}

manager::~manager()
{
	delete [] tokens;
}

void manager::reset()
{
	for (int i=0; i<nTotal; i++) tokens[i].setUnused();
}

bool manager::isTokenFreeForAlloc(uint32_t id, Object *obj)
{
	return tokens[id].isFree();
}

bool manager::isTokenFreeForInquire(uint32_t id, Object *obj)
{
	return tokens[id].isFree();
}

bool manager::isTokenGoodToReclaim(Token *token, Object *obj)
{
	return true;
}

Token *manager::allocateToken(uint32_t id, Object *obj)
{
	tokens[id].setUsed(obj);
	return tokens+id;
}

Token *manager::inquireToken(uint32_t id, Object *obj)
{
	return tokens+id;
}

bool manager::reclaimToken(Token *token, Object *obj)
{
	token->setUnused();
	return true;
}

void manager::discardToken(Token *token, Object *obj)
{
	token->setUnused();
}

