
#ifndef __OBJECT_POOL__
#define __OBJECT_POOL__

#include <list>
#include "object.h"

namespace osm {

class obj_pool {

	public:
		/*forbid the use of copy constructors and copy constructors*/
		obj_pool(const obj_pool&);
		obj_pool& operator=(const obj_pool&);

		obj_pool(int n);
		~obj_pool(); 

		Object *allocate() {
			nFree--;
			assert(!nFree>=0);
			Object *obj = freeList[nFree];
			return obj;
		}

		void release(Object *obj) {
			freeList[nFree] = obj;
			nFree++;
		}

	private:
		std::vector<Object *> freeList;
		std::vector<Object *> objs;
		int nFree;

};

}

#endif
