
#ifndef __SIMPLE_SCHED_H__
#define __SIMPLE_SCHED_H__

#include <vector>
#include <list>
#include "config.h"
#include "bittypes.h"
#include "object_pool.h"
#include "iostream"

namespace osm {
/** an itinerary of an operation */
typedef class scheduler {

	public:
		scheduler(int nobj, void *intface) :
			 workList(), objq(nobj), dynid(0), intface(intface) {}
		~scheduler() {}

		void tick();			/*clock ticks*/
		void squash(uint64_t id);	/*squash all active ones whose dynid>id*/

	private:

		std::list<object *> workList;

		/*the buffer holding all objects*/
		class obj_pool objq;

		uint64_t dynid;

		void *intface;

} Scheduler;

}
#endif
