/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#include "armsim.h"
#include "branch_itin.h"
#include "derived_itinerary.h"
#include "itinerary_pool.h"

using namespace simulator;

Itinerary *itn_branch(arm_simulator *sim, arm_inst_t inst)
{
	Itinerary *itn = sim->itnq->allocate(ITN_BRANCH);
	return itn;
}

Itinerary *itn_branch_link(arm_simulator *sim, arm_inst_t inst)
{
	Itinerary *itn = sim->itnq->allocate(ITN_BRANCH);
	sim->uopBuffer[0] = itn;
	sim->uopBufferSize = 1;

	itn = sim->itnq->allocate(ITN_FILLER);
	uint32_t ids[] = {(uint32_t)-1, 14, 1}; /*link register*/
	itn->setIds(ids);
	return itn;
}

