/*************************************************************************
    Copyright (C) 2002,2003 Wei Qin
    See file COPYING for more information.

    This program is free software; you can redistribute it and/or modify    
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*************************************************************************/

#ifndef __DPI_ITN__
#define __DPI_ITN__

#include "misc.h"

using simulator::arm_simulator;

extern Itinerary *itn_mov_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mov_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mov_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mov_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mov_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mov_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mvn_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mvn_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mvn_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mvn_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mvn_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_mvn_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_add_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_add_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_add_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_add_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_add_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_add_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_adc_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_adc_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_adc_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_adc_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_adc_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_adc_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sub_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sub_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sub_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sub_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sub_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sub_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sbc_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sbc_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sbc_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sbc_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sbc_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_sbc_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsb_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsb_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsb_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsb_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsb_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsb_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsc_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsc_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsc_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsc_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsc_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_rsc_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_and_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_and_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_and_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_and_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_and_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_and_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_eor_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_eor_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_eor_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_eor_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_eor_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_eor_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_orr_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_orr_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_orr_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_orr_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_orr_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_orr_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_bic_1(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_bic_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_bic_2(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_bic_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_bic_3(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_bic_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_cmp_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_cmp_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_cmp_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_cmn_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_cmn_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_cmn_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_tst_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_tst_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_tst_3s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_teq_1s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_teq_2s(arm_simulator *sim, arm_inst_t inst);
extern Itinerary *itn_teq_3s(arm_simulator *sim, arm_inst_t inst);

#endif
